#!/usr/bin/env python

#	programmed Fuse Byte
#	v2.0

#	programmed = 0
#	unprogrammed = 1


import sys
import os
import subprocess
from PyQt4 import QtCore, QtGui

Verbosity = 3

import dataFuseByteValue


class Button( QtGui.QToolButton ):
	''' this class is Button class '''

	def __init__( self, text, index, parent=None ):
		QtGui.QToolButton.__init__( self, parent )  
		#	set button name   
		self.setIndex( index )		
		self.setButtonName( text )


	def checkableButton( self ):
		if self.text == 'None':
			self.setDisabled( True )					
		else:
			self.setCheckable( True )
			self.setDisabled( False )
			
						
	def setIndex( self, index ):
		self.index = int( index )


	def getIndex( self ):
		return self.index


	def getName( self ):
		return self.text


	def setButtonName( self, text ):
		self.text = str(text)
		self.checkableButton()
		self.setText( self.text )		
		#	set tool tip
		try:
			tooltipText = str( dataFuseByteValue.FuseByteDict[self.text] )		
		except KeyError:
			print 'KeyError :: ', self.text
			tooltipText = 'No info'
			
		self.setToolTip( str( tooltipText ) )	
		QtGui.QToolTip.setFont( QtGui.QFont( 'OldEnglish', 12 ) )	
			
					
	def sizeHint( self ):
	#	set button size
		size = QtGui.QToolButton.sizeHint( self )
		size.setHeight( size.height() + 5 )
		size.setWidth( max( size.width(), size.height() ) )
		return size



class objectWidget( QtGui.QWidget ):
		
	def __init__( self, FuseByteTypeList, groupBoxName, parent=None ):
		QtGui.QWidget.__init__( self, parent )		

		self.groupDataByteList = FuseByteTypeList
		self.groupBoxName = groupBoxName
		#	dynamic variable T_T
		self.NumDigitButtons = 8
		self.decValue = 0
		mainLayout = QtGui.QGridLayout()

		groupBoxLayout = self.createGruopButton()
		#	create low & high display textline
		adisplayByte = self.display()

		#	add widget on main grid layout
		mainLayout.addWidget( adisplayByte, 0, 0 )
		mainLayout.addWidget( groupBoxLayout, 1, 0 )

		#	set layout
		self.setLayout( mainLayout ) 		

	def getHexValue( self ):
		return hex(self.decValue)
		
		
	def display( self ):
		#	set default displayByte = 0
		self.displayByte = QtGui.QLineEdit( "0" )
		
		self.displayByte.setReadOnly( True )
		self.displayByte.setAlignment( QtCore.Qt.AlignRight )
		self.displayByte.setMaxLength( 8 )
		
		font = self.displayByte.font()
		font.setPointSize( font.pointSize() + 8 )
		self.displayByte.setFont( font )

		return self.displayByte 	                                        		                                         		                              		
		

	def createGruopButton( self ):
	
		self.digitButton = []				
		
		for index, bitName in enumerate( self.groupDataByteList ):
			#	add button obj in digitButtonList
			self.digitButton.append( self.createButton( QtCore.QString( str(bitName) ), index ) )

			if (Verbosity > 4):
					print index,str(bitName)
									
		groupBox = QtGui.QGroupBox( self.groupBoxName )
		vbox= QtGui.QVBoxLayout()	

		for index in range( len( self.digitButton ) ):
			#	add button on widget, inverse position
			buttonNum =  len( self.digitButton ) - ( index + 1 )
			vbox.addWidget( self.digitButton[ buttonNum ] )

		groupBox.setLayout( vbox )
		return groupBox


	def createButton( self, text, index ):
		self.button = Button( text, index )
		self.connect( self.button, QtCore.SIGNAL( "clicked()" ), self.digitClicked )
		return self.button


	def updateButton( self, buttonNameList ):
		for index, buttonName in enumerate(buttonNameList):		
			self.digitButton[index].setButtonName( buttonName )
				
											
	def clearData( self ):
		self.displayByte.setText( '0' )
		for button in self.digitButton:			
			button.setChecked( False )
		self.decValue = 0
		
		
	def digitClicked( self ):		
		clickedButton = self.sender()
		decValueBuffer = self.decValue ^ ( 1 << clickedButton.getIndex() )

		bi = self.toBinary( decValueBuffer )
		self.decValue = decValueBuffer
		
		textStr =  str( self.groupBoxName )+":: digitClick["+str( clickedButton.getIndex() )+"]"+"-> 0b"+str( bi )
		print  textStr			

		self.displayByte.setText( QtCore.QString( hex(decValueBuffer) ) )


	def toBinary( self, dec ):
		bin = ''
		for x in range( self.NumDigitButtons ):
			bin = str( dec % 2 ) + bin
			dec = int( dec/2 )
		return bin


	def setValue( self, value ):
		self.decValue = value
		self.displayByte.setText( hex(self.decValue) )
		
		bi = self.toBinary( self.decValue )
		
		for i in range( len(self.digitButton) ):		
			if int( bi[ len(self.digitButton) - i -1 ] ) == 1:
				self.digitButton[ i ].setChecked( False )
			else:
				self.digitButton[ i ].setChecked( True )						



class mainWindow( QtGui.QWidget ):

	def __init__( self, parent=None ):
		QtGui.QWidget.__init__( self, parent )
		
		groupBoxNameList = [ 'Fuse High-byte', 'Fuse Low-byte', 'Fuse Extend-byte' ]
		#	set	default
		self.defaultName = 'mega64'
			
		self.comboBoxFileIndexFlag = False	
			
		self.fuseSeries = dataFuseByteValue.aFuseByteDict()
		self.fuseSeries.setName( self.defaultName )
		
		self.setByteValue()			
		
		self.high = objectWidget( self.FuseHighByteList, groupBoxNameList[0] )
		self.low = objectWidget( self.FuseLowByteList, groupBoxNameList[1] )
		self.extend = objectWidget( self.FuseExtendByteList, groupBoxNameList[2] )

		self.high.setValue( self.FusehighDefaultByte )
		self.low.setValue( self.FuselowDefaultByte )
		self.extend.setValue( self.FuseextendDefaultByte )	

		programDetailLabel = QtGui.QLabel( self.tr( "   programmed = 0, unprogrammed = 1" ) )
		programDetailLabel.setFont( QtGui.QFont( 'OldEnglish', 10 ) )

		#	create main grid layout
		self.mainLayout = QtGui.QGridLayout()

		#	add widget on main grid layout
		self.mainLayout.addWidget( self.high, 1, 0 )																			
		self.mainLayout.addWidget( self.low, 1, 1 )
		self.mainLayout.addWidget( self.extend, 1, 2 )

		self.mainLayout.addWidget( self.selectNo(), 0, 0 )
		self.mainLayout.addWidget( programDetailLabel, 0, 1 )		
		
		self.mainLayout.addWidget( self.openFileName(), 2, 0, 1, 2 )		
		self.mainLayout.addWidget( self.createWriteCheckBoxGroup(), 2, 2 )		
				
		#	set layout
		self.setLayout( self.mainLayout )
		
		
	def setByteValue( self ):
	
		self.FuseHighByteList = self.fuseSeries.aFusehighByteList
		self.FuseLowByteList = self.fuseSeries.aFuselowByteList
		self.FuseExtendByteList = self.fuseSeries.aFuseextendByteList
				
		self.FusehighDefaultByte = self.fuseSeries.aFusehighDefaultByte
		self.FuselowDefaultByte = self.fuseSeries.aFuselowDefaultByte
		self.FuseextendDefaultByte = self.fuseSeries.aFuseextendDefaultByte
		
				
	def selectNo( self ):
		
		self.selectNoComboBox = QtGui.QComboBox()		
		self.selectNoComboBox.setFont( QtGui.QFont( 'OldEnglish', 14 ) )
		self.selectNoComboBox.setSizePolicy( QtGui.QSizePolicy.Expanding, 
												QtGui.QSizePolicy.Preferred )
			
		#	set AllSeriesList from import file																						
		AllSeriesList = self.fuseSeries.AllSeries
		
		for index in range( len( AllSeriesList ) ):
			item = str( AllSeriesList[index] )
			self.selectNoComboBox.addItem( item )	
					
			#	check&set default no.
			if item == self.defaultName:			
				self.selectNoComboBox.setCurrentIndex( index )
				
		self.connect(self.selectNoComboBox,
						QtCore.SIGNAL( "activated(const QString &)"), self.refresh )            
		return self.selectNoComboBox
		
		
	def refresh( self ):

		selectedName = self.selectNoComboBox.currentText()

		self.fuseSeries.setName( selectedName )
		
		self.setByteValue()	
								
		self.high.updateButton( self.FuseHighByteList )
		self.low.updateButton( self.FuseLowByteList )
		self.extend.updateButton( self.FuseExtendByteList )	

		self.high.clearData()
		self.low.clearData()	
		self.extend.clearData()	
		
		self.high.setValue( self.FusehighDefaultByte )
		self.low.setValue( self.FuselowDefaultByte )
		self.extend.setValue( self.FuseextendDefaultByte )			
	
		
		
	def openFileName( self ):
		groupBox = QtGui.QGroupBox( self.tr( "File" ) )
		groupBox.setFlat( True )
		
		self.openFileNameComboBox = QtGui.QComboBox()
		self.openFileNameComboBox.setEditable( True )
		self.openFileNameComboBox.setSizePolicy( QtGui.QSizePolicy.Expanding,
				 									QtGui.QSizePolicy.Preferred )
					
		self.openFileNameButton = QtGui.QPushButton( self.tr( "File" ) )
		self.connect( self.openFileNameButton, QtCore.SIGNAL( "clicked()" ), self.setOpenFileName )
		
		hbox = QtGui.QHBoxLayout()
		hbox.addWidget( self.openFileNameComboBox )
		hbox.addWidget( self.openFileNameButton )
		groupBox.setLayout( hbox )

		return groupBox   		

			
	def setOpenFileName( self ):
		fileName = QtGui.QFileDialog.getOpenFileName( self,
		                                    self.tr( "QFileDialog.getOpenFileName()" ),
		                                    self.openFileNameComboBox.currentText(),
		                                    self.tr( "All Files (*);;Hex Files (*.hex);;Text Files (*.txt)") )

		if not fileName.isEmpty():
			self.openFileNameComboBox.addItem( fileName )
			
			#	set combo box current index
			if self.comboBoxFileIndexFlag:
				self.openFileNameComboBox.setCurrentIndex( self.openFileNameComboBox.currentIndex()+1 )
			else:
				self.openFileNameComboBox.setCurrentIndex( self.openFileNameComboBox.currentIndex() )				

			self.comboBoxFileIndexFlag = True
			
	def createWriteCheckBoxGroup( self ):
		groupBox = QtGui.QGroupBox( self.tr( "Write" ) )
		groupBox.setFlat( True )

		self.fuseByteCheckBox = QtGui.QCheckBox( self.tr( "FuseByte" ) )
		self.hexFileCheckBox = QtGui.QCheckBox( self.tr( "HexFile" ) )
		self.WriteButton = QtGui.QPushButton( self.tr( "Write" ) )
		self.hexFileCheckBox.setChecked( True )

		#	send signal click to CheckBox
		self.emit( QtCore.SIGNAL( "clicked()" ), self.fuseByteCheckBox )
		self.emit( QtCore.SIGNAL( "clicked()" ), self.hexFileCheckBox )
		#	if pressed WriteButton, check what obj wanna Write, set cmd parameter
		self.connect( self.WriteButton, QtCore.SIGNAL( "clicked()" ), self.checkWriteStatus )
		
		hbox = QtGui.QHBoxLayout()
		hbox.addWidget( self.fuseByteCheckBox )
		hbox.addWidget( self.hexFileCheckBox )
		hbox.addWidget( self.WriteButton )        
		hbox.addStretch( 1 )
		groupBox.setLayout( hbox )

		return groupBox   


	def errorMessage( self ):
		print 'errorMessage'
		
		if self.openFileNameComboBox.currentText().isEmpty():
		
			errorMessageBox = QtGui.QMessageBox.critical( self,
	                "Select hex file", "You must select hex file first",
	          		QtGui.QMessageBox.Ok )		
		else:
		
			errorMessageBox = QtGui.QMessageBox.critical( self,
	                "Specify Write type", "You must specify Write type\n hex or fuse byte",
	          		QtGui.QMessageBox.Ok )
		

	def checkWriteStatus( self ):
		
		#print 'fuseByte :', self.fuseByteCheckBox.isChecked()
		#print 'hexFile  :', self.hexFileCheckBox.isChecked()

		#	cmd avrdude
		#	avrdude -p m162 -c pony-stk200 -U flash:w:main.hex - U fusebit:w:0xff -E noreset
		
		#	avrdude -p #### -c ##### -U flash:w:####.hex - U fusebit:w:0x## -E noreset		
		
		#	-- writing fuses

		#	Syntax for the low fuse:
		#	avrdude -c dapa -p t2313 -U lfuse:w:0x64:m

		#	and the high:
		#	avrdude -c dapa -p t2313 -U hfuse:w:0xDF:m
		
		avrdudeCmd = '......'
		fuseByteCmd = ''
		hexFile = ''
		
		if ( not self.hexFileCheckBox.isChecked() and not self.fuseByteCheckBox.isChecked() )\
			 or self.openFileNameComboBox.currentText().isEmpty():

			self.errorMessage()				
				
		else:

			if self.fuseByteCheckBox.isChecked():
				fuseByteCmd = '.......'
				print self.high.getHexValue()
				
			if self.fuseByteCheckBox.isChecked():
				hexFile = '....'
				
			print self.openFileNameComboBox.currentText()
			
			setavrdude = ''





if __name__ == "__main__":

	app = QtGui.QApplication( sys.argv )
	window = mainWindow()
	window.show()
	sys.exit( app.exec_() )		

		
